// HTMLパーサー

var __runInDocument = true;

// function debug( message ) {
//     if ( message ) print( message.toString() );
// }

/***********
These commented lines are light-weight alternatives of DOM interfaces for debuggin in Rhino.

****/
// try {
//     if ( window ) {
//         __runInDocument = true;
//     } else {
//         __runInDocument = false;
//     }
// } catch ( e ) {
//     __runInDocument = false;
// {
//     function Node() {}
//     function NodeList() {
//         this.children = new Array();
//         this.length = this.children.length;
//     }
//     NodeList.prototype.item = function ( num ) { return this.children[ num ]; };
//     NodeList.prototype.appendChild = function( node ) {
//         this.children.push( node );
//         this.length ++;
//     };
//     NodeList.prototype.removeChild = function( node ) {
//         for ( var i = this.children.length - 1; i >= 0; i-- ) {
//             if ( this.children[ i ] == node ) {
//                 this.children.splice( i, 1 );
//                 this.length --;
//                 break;
//             }
//         }
//     };

//     function Attribute() {
//         this.values = new Array();
//     }
//     Attribute.prototype.set = function( label, value ) {
//         for ( var i = 0; i < this.values.length; i++ ) {
//             if ( this.values[ i ][ 0 ] == label ) {
//                 this.values[ i ][ 1 ] = value;
//                 return;
//             }
//         }
//         this.values.push( new Array( label, value ) );
//     }
//     Attribute.prototype.get = function( label ) {
//         for ( var i = 0; i < this.values.length; i++ ) {
//             if ( this.values[ i ][ 0 ] == label ) {
//                 return this.values[ i ][ 1 ];
//             }
//         }
//         throw "no attribute for " + label;
//     }
//     Attribute.prototype.remove = function( label ) {
//         for ( var i = 0; i < this.values.length; i++ ) {
//             if ( this.values[ i ][ 0 ] == label ) {
//                 this.values.splice( i, 1 );
//                 break;
//             }
//         }
//     }
//     Attribute.prototype.toString = function() {
//         var output = "";
//         for ( var i = 0; i < this.values.length; i++ ) {
//             output += " " + this.values[ i ][ 0 ] + "=\"" + this.values[ i ][ 1 ] + "\"";
//         }
//         return output;
//     }

//     function Element( qname ) {
//         this.parentNode = null;
//         this.tagName = qname;
//         this.nodeType = 1;
//         this.attribute  = new Attribute();
//         this.childNodes = new NodeList();
//         this.firstChild = null;
//         this.lastChild = null;
//     }

//     Element.prototype.appendChild = function (node) {
//         this.childNodes.appendChild( node );
//         this.firstChild = this.childNodes.item( 0 );
//         this.lastChild = this.childNodes.item( this.childNodes.length - 1 );
//         node.parentNode = this;
//     }
//     Element.prototype.removeChild = function( node ) {
//         this.firstChild = this.childNodes.item( 0 );
//         this.lastChild = this.childNodes.item( this.childNodes.length - 1 );
//         this.childNodes.removeChild( node );
//     }
//     Element.prototype.setAttribute = function( label, value ) {
//         this.attribute.set( label, value );
//     }
//     Element.prototype.getAttribute = function( label ) {
//         this.attribute.set( label );
//     }
//     Element.prototype.removeAttribute = function( label ) {
//         this.attribute.remove( label );
//     }
//     Element.prototype.hasAttribute = function( label ) {
//         try {
//             this.attribute.get( label );
//             return true;
//         } catch ( e ) {
//             return false;
//         }
//     }
//     Element.prototype.toString = function( indent ) {
//         var idtext = ""
//         if ( indent ) {
//             for ( var i = 0; i < indent; i++ ) {
//                 idtext += " ";
//             }
//         } else {
//             indent = 0;
//         }
//         var output = idtext + "<" + this.tagName + this.attribute.toString() + ">\n";
//         for ( var i = 0; i < this.childNodes.length; i++ ) {
//             output += this.childNodes.item( i ).toString( indent + 1 );
//         }
//         output += idtext + "</" + this.tagName + ">\n";
//         return output;
//     }

//     function Text( string ) {
//         this.data = string;
//         this.nodeType = 3;
//         this.parentNode = null;
//     }
//     Text.prototype.toString = function( indent ) { 
//         var output = "";
//         if ( indent ) { 
//             for ( var i = 0; i < indent; i++ ) output += " "; 
//             return output + this.data + "\n"; 
//         } else {
//             return this.data + "\n";
//         }
//     };

//     function Document() {
//     }
//     Document.prototype.createElement = function( qName ) {
//         return new Element( qName );
//     }
//     Document.prototype.createTextNode = function( text ) {
//         return new Text( text );
//     }
//     var document = new Document();

//     __runInDocument = true;
// }

function _HTMLParser() {
    this.parser = new _HTMLHandler();
    this.attrRegex = new RegExp( "([a-zA-Z0-9_\\-]+)(\\s*=\\s*)?(('[^']*?')|(\"[^\"]*?\")|([^'\"\\s]*))", "gm" );
    this.nullArrtibute = new Array();
    this.singleTags = [ "BR", "META", "IMG", "HR", "INPUT", "PARAM" ];
    this.nestInhibitedTags = [ "LI", "TR", "TD" ];
    this.ignoringTags = [ "FONT", "FONTSIZE", "B", "I" ];
}

/**
   Create attribute from a text in an element tag.
 */
function _HTMLParser__createAttribute( text ) {
    //try {
    this.attrRegex.lastIndex = 0;
    var am = this.attrRegex.exec( text );
    var at = null;
        
    if ( am ) {
        at = new Array();
        while ( am ) {
            var label = am[ 1 ];
            var value;
            if ( am[ 2 ] ) {
                if ( am[ 4 ] != null || am[ 5 ] != null ) {
                    value = am[ 3 ].substring( 1, am[ 3 ].length - 1 );
                } else if ( am[ 6 ] ) {
                    value = am[ 6 ];
                } else {
                    value = "";
                }
                if ( label != null && value != null ) {
                    at.push( new Array( label, value ) );
                }
                //} else {
                //at.push( new Array( label, "" ) );
            }
            am = this.attrRegex.exec( text );
        }
        return at;
    } else {
        return this.nullAttribute;
    }
}

/**
   Parse HTML document and call HTML handler.
 */
function _HTMLParser__parse( text ) {
    var _HTML_elementRegex = new RegExp( "(<([a-zA-Z][0-9\\-_A-Za-z]*)\\s*([^>]*)>)|(</([^>]+)\\s*>)", "img" );
    var _HTML_spaceRegex = new RegExp( "[\\s\\W]+" );
    var _HTML_commentRegex = new RegExp( "\\s*<!\-\-(.*?)\-\->\\s*", "gm" );
    var matches = _HTML_elementRegex.exec( text );
    var pos = 0;

    while ( matches ) {
        var start = matches[ 2 ];
        var end   = matches[ 4 ];

        var pos_match = _HTML_elementRegex.lastIndex - matches[ 0 ].length;
        // strip the text and append Text if the text is not null
        var p0;
        var p1;
        for ( p0 = pos; p0 < pos_match; p0++ ) {
            var ct = text.charAt( p0 );
            if ( ct != "\n" && ct != " " ) {
                //pos = p0;
                break;
            }
        }
        for ( p1 = pos_match - 1; p1 >= pos; p1 -- ) {
            var ct = text.charAt( p1 );
            if ( ct != "\n" && ct != " " ) {
                p1 ++;
                //pos_match = p0;
                break;
            }
        }

        // separate texts and comments and append to parent node
        if ( p1 - p0 > 0 ) {
            // remove comment and apply it
            _HTML_commentRegex.lastIndex = 0;
            var chrs = text.substring( p0, p1 );
            //debug( chrs );
            var cp0 = 0;
            var cp1 = chrs.length;
            var cmmatches = _HTML_commentRegex.exec( chrs );
            while ( cmmatches ) {
                var cp1 = _HTML_commentRegex.lastIndex - cmmatches[ 0 ].length;
                if ( cp1 - cp0 > 0 ) {
                    this.parser.characters( chrs.substring( cp0, cp1 ) );
                }
                cp0 = _HTML_commentRegex.lastIndex;
                this.parser.comment( cmmatches[ 1 ] );
                cmmatches = _HTML_commentRegex.exec( chrs );
            }
            if ( cp0 < chrs.length ) {
                this.parser.characters( chrs.substring( cp0, chrs.lenth ) );
            }
        }
 
        if ( start ) {
            start = start.toUpperCase();
            var flag_ignore = false;
            for ( var j = 0; j < this.ignoringTags.length; j++ ) {
                if ( this.ignoringTags[ j ] == start ) {
                    flag_ignore = true;
                    break;
                }
            }

            var flag_nest = false;
            //debug( flag_ignore + " " + this.currentElement );
            if ( flag_ignore == false && this.parser.currentElement != null 
                 && this.parser.currentElement.tagName == start ) {
                for ( var j = 0; j < this.nestInhibitedTags.length; j++ ) {
                    if ( this.nestInhibitedTags[ j ] == start ) {
                        flag_nest = true;
                        this.parser.endElement( start );
                        break;
                    }
                }
            }

            if ( flag_ignore == false ) {
                var attrs = this.createAttribute( matches[ 3 ] );
                this.parser.startElement( start, attrs );
                // if the tagName is one of singular, endElement
                // is called soon after startElement
                try {
                    for ( var j = 0; j < this.singleTags.length; j++ ) {
                        if ( this.singleTags[ j ] == start ) {
                            this.parser.endElement( start );
                            //debug( ">>>>> ended" );
                            break;
                        }
                    }
                } catch ( e ) {
                    debug( "multiple document, exit" );
                    break;
                }
            }
        } else if ( end ) {
            this.parser.endElement( matches[ 5 ].toUpperCase() );
        }

        pos = pos_match + matches[ 0 ].length;
        matches = _HTML_elementRegex.exec( text );
        //debug( "matching end"  + matches );
    }
    //debug( "all parsed" );
    //return this.parser.rootElement;
    return this.parser.document;
}

_HTMLParser.prototype.parse = _HTMLParser__parse;
_HTMLParser.prototype.createAttribute = _HTMLParser__createAttribute;
_HTMLParser.prototype.setHandler = function( handler ) { this.parser = handler; };

// SAX handler of HTML document
function _HTMLHandler() {
    //this.root = document.createElement( "html" );
//     this.rootElement = null;
//     this.currentElement = null;//this.root;
    this.document = document.implementation.createDocument( "", "", null );
    this.rootElement     = this.document.createElement( "HTMLDOC" );
    this.currentElement  = this.rootElement;
    this.document.appendChild( this.rootElement );
}

// begin element
function _HTMLHandler__startElement( qName, attrs ) {//namespaceURI, localName, qName, attrs ) {
    //debug( "start element " + qName );
    var elem = this.document.createElement( qName );
    if ( attrs ) {
        for ( var i = 0; i < attrs.length; i++ ) {
            //debug( attrs[ i ][ 0 ] + ", " + attrs[ i ][ 1 ] );
            elem.setAttribute( attrs[ i ][ 0 ], attrs[ i ][ 1 ] );
        }
    }
    if ( this.currentElement ) {
        this.currentElement.appendChild( elem );
        //debug( "# of children : " + this.currentElement.childNodes.length + " / " + this.currentElement.tagName );
    } else {
        if ( this.rootElement ) {
            throw "two documents";
        }
        this.rootElement = elem;
        this.document.appendChild( elem );
    }
    this.currentElement = elem;
}

// end element
function _HTMLHandler__endElement( qName ) {//namespaceURI, localName, qName ) {
    //debug( "end element " + qName + " / " + this.currentElement.tagName  + " : " + ( qName == this.currentElement.tagName ) );
    if ( qName == this.currentElement.tagName ) {
        //if ( __runInDocument == false ) print( "end element " + qName );
        if ( this.currentElement ) {
//            debug( "to parent" );
            this.currentElement = this.currentElement.parentNode;
        } else { // no element, exit parsing
//            debug( "???" );
            this.currentElement = null;
        }
        return;
    } else {
        // mismatch
        var elem = this.currentElement.parentNode;
        while ( elem ) {
            if ( elem.tagName == qName ) {
                this.currentElement = elem.parentNode;
                return;
            }
            elem = elem.parentNode;
        }
    }
    //debug( "not found element" );
}

// text
function _HTMLHandler__characters( text ) {
    if ( text == null || text.length == 0 ) return;
    //debug( "characters " + text );
    var tx = this.document.createTextNode( text );
    if ( this.currentElement ) {
        this.currentElement.appendChild( tx );
    }
}

function _HTMLHandler__comment( commenttext ) {
    if ( commenttext == null ) return;
    var cm = this.document.createComment( commenttext );
    //debug( "comment   " + commenttext + " :: " + cm.nodeType );
    if ( this.currentElement ) {
        this.currentElement.appendChild( cm );
    }
}

_HTMLHandler.prototype.startElement = _HTMLHandler__startElement;
_HTMLHandler.prototype.endElement = _HTMLHandler__endElement;
_HTMLHandler.prototype.characters = _HTMLHandler__characters;
_HTMLHandler.prototype.comment = _HTMLHandler__comment;

function getInsideTexts( elem, separator, path ) {
    if ( path ) {
        elem = getElementAt( elem, path );
    }
    if ( elem == null ) return;
    if ( separator == undefined ) separator = "";
    return _getTextAt( elem, separator );
}


// function getTextAt( elem, separator, path ) {
//     elem = getElementAt( elem, path );
//     if ( separator == undefined ) separator = "";
//     if ( elem == null ) return;
//     return _getTextAt( elem, separator );
// }
function _getTextAt( elem, separator ) {
    var children = elem.childNodes;
    var output = "";
    for ( var i = 0; i < children.length; i++ ) {
        var child = children.item( i );
        if ( child.nodeType == 3 ) { // text
            if ( output == null ) output = child.data;
            else output += separator + child.data;
        } else if ( child.nodeType == 1 ) {
            if ( output == null ) output = _getTextAt( child, separator );
            else output += separator + _getTextAt( child, separator );
        }
    }
    return output;
}

/** get Element node at a path.
    A path is given as "my/element/path" for <root><my><element><path></path></element></my></root>
 */
function getElementAt( elem, path ) {
    var names = path.toUpperCase().split( "/" );
    var children = elem.childNodes;
    return _getElementAt( elem, names, 0 );
}
// recursive function called by getElementAt
function _getElementAt( elem, names, num ) {
    //debug( elem.tagName + " : " + names[ num ] );
    var items = names[ num ].split( "," );
    var cn = 1;
    if ( items.length > 1 ) {
        cn = parseInt( items[ 1 ] );
    }
    var children = elem.childNodes;
    var last = ( names.length - 1 == num );
    for ( var i = 0; i < children.length; i++ ) {
        var child = children.item( i );
        if ( child.nodeType == 1 ) {
            if ( child.tagName == items[ 0 ] ) {
                cn --;
                if ( cn <= 0 ) {
                    if ( last ) return child;
                    return _getElementAt( child, names, num + 1 );
                }
            }
        }
    }
    return null;
}


// 
function outputDOMText( elem, callback ) {
    _outputDOMText( elem, "", elem, callback );
}

function _outputDOMText( elem, indent, parent, callback ) {
    var output = indent + "<" + elem.tagName;
    var attrs = elem.attributes;
    for ( var i = 0; i < attrs.length; i++ ) {
        var label = attrs.item( i ).name;
        var value = attrs.item( i ).value;
        output += " " + label + "=\"" + value + "\"";
    }
    var _children = elem.childNodes;
    if ( _children.length > 0 ) {
        output += "> <!-- " + _getPathFromParent( elem, parent ) + " -->";
        callback( output );
        var indent_next = indent + "  ";
        for ( var i = 0; i < _children.length; i++ ) {
            var child = _children.item( i );
            if ( child.nodeType == 1 ) {
                _outputDOMText( child, indent_next, parent, callback );
                //output += _convertDOMToText( child, indent_next );
            } else if ( child.nodeType == 3 ) {
                callback( indent_next + child.data );
            } else if ( child.nodeType == 8 ) { // comment
                callback( indent_next + "<!--=== " + child.data + " ===-->" );
            }
        }
        
        callback( indent + "</" + elem.tagName + ">" );
    } else {
        output += "/>  <!-- " + _getPathFromParent( elem, parent ) + " -->";
        callback( output );
    }
}

function convertDOMToText( elem ) {
    return _convertDOMToText( elem, "" );
}
function _convertDOMToText( elem, indent ) {
    //debug( elem.tagName + " " + indent.length + " " + elem.childNodes.length);
    var idtext = indent + " ";
    var output = idtext + "<" + elem.tagName;
    var attrs = elem.attributes;
    for ( var i = 0; i < attrs.length; i++ ) {
        var label = attrs.item( i ).name;
        var value = attrs.item( i ).value;
        output += " " + label + "=\"" + value + "\"";
    }

    if ( elem.childNodes.length == 0 ) {
        output += "/>";
    } else {
        output += ">";
        
        var _children = elem.childNodes;
        for ( var i = 0; i < _children.length; i++ ) {
            var child = _children.item( i );
            if ( child.nodeType == 1 ) {
                output += _convertDOMToText( child, idtext );
            } else if ( child.nodeType == 3 ) {
                output += idtext + child.data + "\n";
            } else if ( child.nodeType == 8 ) { // comment
                output += idtext + "<<<!-- " + child.data + " -->>>\n";
            }
        }
        output += idtext + "</" + elem.tagName + ">\n";
    }
    return output;
}

function _getPathFromParent( elem, parent ) {
    var path = elem.tagName;
    if ( elem == parent ) return path;
    var el = elem.parentNode;
    while ( el ) {
        //debug( el );
        if ( el.nodeType == undefined ) break;
        if ( el.nodeType != 1 ) {
            return path;
        }
        path = el.tagName + "/" + path;
        if ( el == parent ) {
            return path;
        }
        el = el.parentNode;
    }
    return path;
}

